--- old/usr/src/cmd/cmd-inet/usr.lib/in.ndpd/main.c	2012-10-01 02:16:58.431426271 +0000
+++ new/usr/src/cmd/cmd-inet/usr.lib/in.ndpd/main.c	2012-10-01 02:16:58.470367472 +0000
@@ -925,39 +925,25 @@
 		timerval = _B_FALSE;
 	}
 
+	/* Open pid file, blow away any existing file if it exists. */
+	if ((pidfp = fopen(PATH_PID, "w")) == NULL) {
+		(void) fprintf(stderr, "%s: unable to open " PATH_PID ": %s\n",
+		    argv0[0], strerror(errno));
+	}
+
 	/* Daemonize. */
-	switch (fork()) {
-	case 0:
-		/* Child */
-		break;
-	case -1:
+	if (daemon(0, 0) == -1) {
 		logperror("fork");
 		exit(1);
-	default:
-		/* Parent */
-		_exit(0);
 	}
 
-	/* Store our process id, blow away any existing file if it exists. */
-	if ((pidfp = fopen(PATH_PID, "w")) == NULL) {
-		(void) fprintf(stderr, "%s: unable to open " PATH_PID ": %s\n",
-		    argv0[0], strerror(errno));
-	} else {
+	/* Store our process id */
+	if (pidfp != NULL) {
 		(void) fprintf(pidfp, "%ld\n", getpid());
 		(void) fclose(pidfp);
 		(void) chmod(PATH_PID, pidmode);
 	}
 
-	(void) close(0);
-	(void) close(1);
-	(void) close(2);
-
-	(void) chdir("/");
-	(void) open("/dev/null", O_RDWR);
-	(void) dup2(0, 1);
-	(void) dup2(0, 2);
-	(void) setsid();
-
 	already_daemonized = _B_TRUE;
 
 	/*
